#include "window.h"
#include "ui_window.h"
#include <QApplication>
#include <QTextEdit>
#include <sstream> // class ostringstream
#include <stdexcept>

using namespace std;

const int R = 3; // pocet radek
const int S = 3; // pocet sloupcu

const char name [S+1] = "xyz";

double a [R] [S] = { { 3, 2, 1},
                     { 0, 1, 1},
                     { 1, 0, 1 } };

double b [R] = { 28, 32, 40 } ;
// double b [R] = { 1 , 1 , 1 };

string num (double v);
void print (string t);
void error (string msg);

void display ()
{
   for (int i = 0; i < R; i++)
   {
      string t = "";
      for (int j = 0; j < S; j++)
      {
         if (j > 0 && a[i][j] >= 0)
         {
            t = t + "+";
         }
         t = t + num (a[i][j]) + name [j] + " ";
      }
      t = t + "= " + num (b[i]);
      print (t);
   }
   print ("");
}

void solve ()
{
   display ();
}

/* output to window */

QTextEdit * edit = NULL;

void print (string t)
{
   if (edit != NULL)
      edit->append (t.c_str ());
}

void error (string t)
{
   print ("Error: " + t);
   throw runtime_error (t);
}

string num (double v)
{
   ostringstream f;
   f << v;
   return f.str();
}

/* window */

Window::Window(QWidget *parent) :
   QMainWindow(parent),
   ui(new Ui::Window)
{
   ui->setupUi(this);
   edit = ui->textEdit;
}

Window::~Window()
{
   delete ui;
}

void Window::on_actionRun_triggered()
{
   ui->textEdit->clear ();
   solve ();
}

int main(int argc, char *argv[])
{
   QApplication a(argc, argv);
   Window w;
   w.show();

   return a.exec();
}

